
DECLARE SUB InitPalette ()
DECLARE SUB WechselPalette ()
DECLARE SUB ZeichneEllipsen ()
DEFINT A-Z
DIM SHARED PaletteFeld(15)
SCREEN 8            ' Auflsung 640 x 200; 16 Farben
InitPalette         ' Initialisiere PaletteFeld.
ZeichneEllipsen     ' Zeichne und male konzentrische
		    ' Ellipsen.
DO                  ' Schalte die Palette um, bis eine
		    ' Taste bettigt wird.
   WechselPalette
LOOP WHILE INKEY$ = ""
END





'
' =================== InitPalette ====================
'    Diese Prozedur initialisiert das zum Wechseln der
'    Palette verwendete ganzzahlige Datenfeld.
' ====================================================
'
SUB InitPalette STATIC
   FOR I = 0 TO 15
      PaletteFeld(I) = I
   NEXT I
END SUB

'
' ================= WechselPalette ===================
'    Diese Prozedur lt die Palette bei jedem Aufruf
'    um eins rotieren. Z. B. ist nach dem ersten
'    Aufruf von WechselPalette PaletteFeld(1) = 2,
'    PaletteFeld(2) = 3, . . . , PaletteFeld(14) = 15
'    und PaletteFeld(15) = 0
' ====================================================
'
SUB WechselPalette STATIC
   FOR I = 1 TO 15
      PaletteFeld(I) = (PaletteFeld(I) MOD 15) + 1
   NEXT I
   PALETTE USING PaletteFeld(0) ' Schalte die von
				' jeder der 15
				' Attribute angezeigte
				' Farbe um.
END SUB

'
' ================= ZeichneEllipsen ==================
'    Diese Prozedur zeichnet 15 konzentrische Ellipsen
'    und malt das Innere einer jeden mit einer anderen
'    Farbe aus.
' ====================================================
'
SUB ZeichneEllipsen STATIC
   CONST ASPEKT = 1 / 3
   FOR FarbWert = 15 TO 1 STEP -1
      Radius = 20 * FarbWert
      CIRCLE (320, 100), Radius, FarbWert, , , ASPEKT
      PAINT (320, 100), FarbWert
   NEXT
END SUB

