DECLARE FUNCTION Filter$ (Txt$, FilterZeichKett$)
CLS
' Gib eine Zeile ein:
LINE INPUT "Geben Sie eine Zahl mit Kommata ein: ", A$
' Suche nur nach gltigen numerischen Zeichen
' (0123456789.-) in der eingegebenen Zeichenkette:
GueltZahl$ = Filter$(A$, "0123456789.-")
' Wandle die Zeichenkette in eine Zahl um:
PRINT "Zahlenwert = "; VAL(GueltZahl$)
END


'
' ===================== FILTER =======================
'      Entfernt aus einer Zeichenkette ungewollte
'      Zeichen, indem sie diese mit einer
'      Filterzeichenkette vergleicht, die nur
'      zulssige numerische Zeichen enthlt
' ====================================================
'
FUNCTION Filter$ (Txt$, FilterZeichKett$) STATIC
   Temp$ = ""
   TxtLaenge = LEN(Txt$)
   FOR I = 1 TO TxtLaenge     ' Isoliere jedes Zeichen
      C$ = MID$(Txt$, I, 1)   ' der Zeichenkette.
      ' Wenn sich das Zeichen in der
      ' Filterzeichenkette befindet, sichere es:
      IF INSTR(FilterZeichKett$, C$) <> 0 THEN
        Temp$ = Temp$ + C$
      END IF
   NEXT I
   Filter$ = Temp$
END FUNCTION

