DECLARE SUB Befzeile (AnzArgte%, Argte$(), MaxArgte%)
DECLARE SUB Ausdruck (F$(), N%)
' *** CALL_EX.BAS
'
' In der Befehlszeile mssen 3 oder mehr Dateien angegeben werden.
' Danach folgt der Name einer Datei, in die diese Dateien
' zusammengefat geschrieben werden sollen. Gleichzeitig werden die
' Dateien auf dem Bildschirm ausgegeben.
'
DEFINT A-Z
CONST MAXDATEIEN = 5, DATFELDGR = MAXDATEIEN + 1
DIM Datei$(1 TO DATFELDGR)
' Spalte Befehlszeile in Argumente auf.
CALL Befzeile(AnzArgte, Datei$(), DATFELDGR)
IF AnzArgte < 3 OR AnzArgte > MAXDATEIEN THEN
  ' Zuviele oder nicht genug Dateien.
   PRINT "Benutze mehr als 3 und weniger als"; MAXDATEIEN; "Dateien"
ELSE
  ' Ausdruck der Dateienliste.
   CALL Ausdruck(Datei$(), AnzArgte)
END IF
END

SUB Ausdruck (F$(), N) STATIC
   ' ffne Zieldatei.
   OPEN F$(N) FOR OUTPUT AS #3
   ' Schleife wird einmal pro Datei durchlaufen.
   ' Kopiere die ersten N-1 Dateien in die N-te Datei.
   FOR Datei = 1 TO N - 1
      OPEN F$(Datei) FOR INPUT AS #1
      DO WHILE NOT EOF(1)
	 'Lese Datei.
	 LINE INPUT #1, Zwsp$
	 'Schreibe Daten in die Zieldatei.
	 PRINT #3, Zwsp$
	 PRINT Zwsp$
      LOOP
      CLOSE #1
    NEXT
    CLOSE
END SUB

SUB Befzeile (AnzArgte, Argte$(), MaxArgte) STATIC
' Unterprogramm, um Befehszeile zu lesen und in Argumente aufzuspalten.
' Parameters:  AnzArgte : Anzahl der gefundenen Argumente.
'              Argte$() : Datenfeld mit Argumenten.
'              MaxArgte : Grte Anzahl der Argumente
CONST WAHR = -1, FALSCH = 0
AnzArgte = 0: In = FALSCH
' Liest die Kommandozeile unter Verwendung der COMMAND$-Funktion.
   Cl$ = COMMAND$
   L = LEN(Cl$)
' Durchlaufe die Kommandozeile Buchstabe fr Buchstabe.
   FOR I = 1 TO L
      C$ = MID$(Cl$, I, 1)
      'Teste auf Leerzeichen oder Tabulator.
      IF (C$ <> " " AND C$ <> CHR$(9)) THEN
	 ' Weder Leerzeichen noch Tabulator.
	 ' Test schon im Argument.
	 IF NOT In THEN
	 ' Anfang eines neuen Arguments gefunden.
	 ' Test auf berlauf der Argumenteanzahl.
	    IF AnzArgte = MaxArgte THEN EXIT FOR
	    AnzArgte = AnzArgte + 1
	    In = WAHR
	 END IF
	 ' Fge den Buchstaben dem momentanen Argument an.
	 Argte$(AnzArgte) = Argte$(AnzArgte) + C$
      ELSE
	 ' Leerzeichen oder Tabulator gefunden.
	 ' Setze "Nicht im Argument" Flag auf FALSCH.
	 In = FALSCH
      END IF
   NEXT I
END SUB

