' *** SHELL_EX.BAS ***  SHELL Befehl  Programmbeispiel
'
DECLARE FUNCTION EingName$ (VerzZeile$)
LINE INPUT "Geben Sie das Ziellaufwerk und das Verzeichnis ein: ", PfadSpez$
SHELL "DIR > DATVERZ"    'Speichere das Verzeichnis in DATVERZ.
DO
   OPEN "DATVERZ" FOR INPUT AS #1
   INPUT "Geben Sie das Datum ein (MM-DD-YY) ", Datum$
   PRINT
   ' Lese DATVERZ, berprfe auf korrektes Datum.
   DO
      LINE INPUT #1, VerzZeile$
      ' Prfe  die Zeile des Verzeichnisses auf korrektes Datum und ob
      ' sie nicht eine der speziellen Verzeichnisse enthlt (. oder ..)
      IF INSTR(VerzZeile$, Datum$) > 0 AND LEFT$(VerzZeile$, 1) <> "." THEN
	 DateiSpez$ = EingName$(VerzZeile$)
	 ' Bewege nicht die zeitweise Datei.
	 IF DateiSpez$ <> "DATVERZ" THEN
	    ' Setze DOS Kommandozeile zusammen, um Datei zu kopieren
	    DOSZeile$ = "COPY " + DateiSpez$ + "  " + PfadSpez$
	    PRINT DOSZeile$
	    ' Kopiere Datei
	    SHELL DOSZeile$
	 END IF
      END IF
   LOOP UNTIL EOF(1)
CLOSE #1
   PRINT "Neues Datum ?"
   R$ = INPUT$(1)
   CLS
LOOP UNTIL UCASE$(R$) <> "J"
' KILL "DATVERZ".
END

FUNCTION EingName$ (VerzZeile$) STATIC
' This function gets the file name and extension from
' the VERZectory-listing Zeile.
   BaseName$ = RTRIM$(LEFT$(VerzZeile$, 8))
   ' Check for extension.
   ExtName$ = RTRIM$(MID$(VerzZeile$, 10, 3))
   IF ExtName$ <> "" THEN
      BaseName$ = BaseName$ + "." + ExtName$
   END IF
   EingName$ = BaseName$
END FUNCTION

