DECLARE FUNCTION FeldGroesse (WLinks, WRechts, WOben, WUnten)
SCREEN 2
' Definiere ein Darstellungsfeld und zeichne hierum
' einen Rahmen:
VIEW (20, 10)-(620, 190), , 1
CONST PI = 3.141592653589#
' Definiere die Koordinaten des Darstellungsfeldes neu
' mit logischen Koordinaten:
WINDOW (-3.15, -.14)-(3.56, 1.01)
' Die Datenfelder im Programm sind nun dynamisch:
' $DYNAMIC
' Berechne die logischen Koordinaten fr den oberen
' und unteren Rand eines Rechtecks gengend gro, um das
' Bild aufzunehmen, das mit CIRCLE und PAINT gezeichnet
' wird:

' Das Rechteck ist kleiner als das im vorhergehenden
' Programm, daher ist auch Feld kleiner:
WLinks = -.18
WRechts = .18
WOben = .05
WUnten = -.05
' Rufe die Funktion FeldGroesse auf und bergib ihr
' die logischen Koordinaten des Rechtecks:
FeldGross% = FeldGroesse(WLinks, WRechts, WOben, WUnten)
DIM Feld(1 TO FeldGross%)  AS INTEGER
' Zeichne und male den Kreis aus:
CIRCLE (0, 0), .18
PAINT (0, 0)
' Speichere das Rechteck in Feld:
GET (WLinks, WOben)-(WRechts, WUnten), Feld
CLS
' Zeichne ein Rechteck und flle es mit einem Muster aus:
LINE (-3, .8)-(3.4, .2), , B
Muster$ = CHR$(126) + CHR$(0) + CHR$(126) + CHR$(126)
PAINT (0, .5), Muster$
LOCATE 21, 29
PRINT "Beenden mit beliebiger Taste"
' Initialisiere die Schleifenvariablen:
SchrWeit = .02
StartSchleife = -PI
NimmAb = 1

DO
   EndSchleife = -StartSchleife
   FOR X = StartSchleife TO EndSchleife STEP SchrWeit
      Y = ABS(COS(X)) * NimmAb - .14
      ' Die erste PUT-Anweisung plaziert das Bild auf
      ' dem Bildschirm:
      PUT (X, Y), Feld, XOR
      ' Verwende eine leere FOR...NEXT-Schleife, um
      ' das Programm zu verzgern und das Bildflimmern
      ' zu verringern:
      FOR I = 1 TO 5: NEXT I
      IF Y < -.13 THEN NimmAb = NimmAb * .9
      Esc$ = INKEY$
      IF Esc$ <> "" OR NimmAb < .01 THEN EXIT FOR
      ' Die zweite PUT-Anweisung lscht das Bild und
      ' stellt den Hintergrund wieder her:
      PUT (X, Y), Feld, XOR
   NEXT X
   SchrWeit = -SchrWeit
   StartSchleife = -StartSchleife
LOOP UNTIL Esc$ <> "" OR NimmAb < .01
END

REM $STATIC
FUNCTION FeldGroesse (WLinks, WRechts, WOben, WUnten) STATIC

REM $DYNAMIC
   ' Bilde die an diese Funktion bergebenen logischen
   ' Koordinaten auf deren entsprechende physikalische
   ' Koordinaten ab:
   VLinks = PMAP(WLinks, 0)
   VRechts = PMAP(WRechts, 0)
   VOben = PMAP(WOben, 1)
   VUnten = PMAP(WUnten, 1)
   ' Berechne die Hhe und Breite des umschlieenden
   ' Rechtecks in Bildpunkten:
   RechtHoehe = ABS(VUnten - VOben) + 1
   RechtBreit = ABS(VRechts - VLinks) + 1
   ' Berechne Gre des Datenfeldes in Bytes:
   ByteGross = 4 + RechtHoehe * INT((RechtBreit + 7) / 8)
   ' Datenfeld ist Ganzzahl, also dividiere Bytes
   ' durch 2:
   FeldGroesse = ByteGross \ 2 + 1

END FUNCTION

