DECLARE SUB ZchnFenster (ObZeile%, ObSpalte%, UntZeile%, UntSpalte%)
' *** CHR_EX.BAS ***
'
DEFINT A-Z
' Zeichne zwei Fenster mit einem Rand aus zwei Linien.
CALL ZchnFenster(5, 22, 18, 40)
CALL ZchnFenster(1, 4, 4, 50)
END

' Unterprogramm, um Fenster zu zeichnen.
' Parameter:
'  ObZeile%, ObSpalte% : Zeile und Spalte fr obere linke Ecke.
'  UntZeile%, UntSpalte% : Zeile und Spalte fr untere rechte Ecke.
'  Konstanten fr den erweiterten ASCII-Grafikzeichensatz.
CONST OLINKE = 201, ORECHTE = 187, VERTIKAL = 186, HORIZONTAL = 205
CONST ULINKE = 200, URECHTE = 188

SUB ZchnFenster (ObZeile%, ObSpalte%, UntZeile%, UntSpalte%) STATIC
   ' Zeichne oberen Rand des Fensters.
   LOCATE ObZeile%, ObSpalte%: PRINT CHR$(OLINKE);
   LOCATE , ObSpalte% + 1:
   PRINT STRING$(UntSpalte% - ObSpalte%, CHR$(HORIZONTAL));
   LOCATE , UntSpalte%: PRINT CHR$(ORECHTE);
   ' Zeichne mittleren Teil des Fensters.
   FOR I = ObZeile% + 1 TO UntZeile% - 1
      LOCATE I, ObSpalte%: PRINT CHR$(VERTIKAL);
      LOCATE , UntSpalte%: PRINT CHR$(VERTIKAL);
   NEXT I
   ' Zeichne unteren Rand des Fensters.
   LOCATE UntZeile%, ObSpalte%: PRINT CHR$(ULINKE);
   LOCATE , ObSpalte% + 1:
   PRINT STRING$(UntSpalte% - ObSpalte%, CHR$(HORIZONTAL));
   LOCATE , UntSpalte%: PRINT CHR$(URECHTE);
END SUB

