DECLARE SUB Ton (Freq!, Laenge!)
'*** OUT Befehl  Programmbeispiel
'
' Spiele eine Tonleiter unter Verwendung von Lautsprecher und Zeitgeber
CONST Ganze = 5000!, Viertel = Ganze / 4!
CONST C = 523!, D = 587.33, E = 659.26, F = 698.46, G = 783.99, A = 880!
CONST B = 987.77, C1 = 1046.5
CALL Ton(C, Viertel): CALL Ton(D, Viertel)
CALL Ton(E, Viertel): CALL Ton(F, Viertel)
CALL Ton(G, Viertel): CALL Ton(A, Viertel)
CALL Ton(B, Viertel): CALL Ton(C1, Ganze)

SUB Ton (Freq!, Laenge!) STATIC
'Die Ausgnge 66, 67, und 97 steuern Zeitgeber und Lautsprecher
'
'Teile die Taktfrequenz durch die Tonfrequenz, um die
'Anzahl der Taktzyklen zu erhalten
    Zyklen% = CINT(1193280! / Freq!)
    NiedrByte% = Zyklen% AND &HFF
    HochByte% = Zyklen% \ 256
'Signalisiere dem Zeitgeber, da Daten kommen
    OUT 67, 182
'Sende die Daten zum Zeitgeber
    OUT 66, NiedrByte%
    OUT 66, HochByte%
'Schalte den Lautsprecher durch Einschalten der Bits 0 und 1 des PPI Chip ein.
    LtsprEin% = INP(97) OR &H3
    OUT 97, LtsprEin%
'Lasse den Lautsprecher eingeschaltet
    FOR I! = 1 TO Laenge!: NEXT I!
'Schalte den Lautsprecher aus.
    LtsprAus% = INP(97) AND &HFC
    OUT 97, LtsprAus%
END SUB

