DECLARE SUB ZeigeKarte (EinzelKarte AS ANY)
DECLARE SUB ErzeugeStapel (Stapel() AS ANY)
DECLARE SUB Mische (Stapel() AS ANY)
'
' *** TYPE_EX.BAS -- TYPE Befehl  Programmbeispiel
'
TYPE Karte
   Wert AS INTEGER
   Farbe AS STRING * 9
END TYPE

DEFINT A-Z
' Definiere den Stapel als 52-elementiges Datenfeld von Karten
DIM Stapel(1 TO 52) AS Karte

' Erzeuge und mische den Stapel und teile die oberen fnf Karten aus.
CALL ErzeugeStapel(Stapel())
CALL Mische(Stapel())
PRINT : PRINT
FOR I% = 1 TO 5
   CALL ZeigeKarte(Stapel(I%))
NEXT I%

' Erzeuge den Stapel--flle das Datenfeld der Karten mit den
' den entsprechenden Werten.
SUB ErzeugeStapel (Stapel() AS Karte) STATIC
DIM Farbe(4) AS STRING * 9

   Farbe(1) = "Herz"
   Farbe(2) = "Kreuz"
   Farbe(3) = "Karo"
   Farbe(4) = "Pik"
' Diese Schleife erzeugt die Farbe.
   FOR I% = 1 TO 4
    ' Diese Karte erzeugt den Wert.
      FOR J% = 1 TO 13
       ' Bestimme, welche Karte (1..52) jetzt definiert werden soll.
         KarteNum% = J% + (I% - 1) * 13
       ' Versieh die Karte mit Wert und Farbe.
         Stapel(KarteNum%).Wert = J%
         Stapel(KarteNum%).Farbe = Farbe(I%)
      NEXT J%
   NEXT I%

END SUB

' Mische den Stapel (ein Datenfeld, das 52 mal Karte enthlt..
SUB Mische (Stapel() AS Karte) STATIC

   RANDOMIZE TIMER
' Mische die Karten durch 1000maliges Austauschen von zufllig ausgesuchten
' Kartenpaaren
   FOR I% = 1 TO 1000
      KarteEins% = INT(52 * RND + 1)
      KarteZwei% = INT(52 * RND + 1)
   ' Beachten Sie, da der Befehl SWAP auch auf benutzerdefinierte Datentypen
   ' angewendet werden kann.
      SWAP Stapel(KarteEins%), Stapel(KarteZwei%)
   NEXT I%

END SUB

' Zeige eine einzelne Karte durch Konvertierung der Wert- und
' Farbeinformation und Ausgabe auf dem Bildschirm
SUB ZeigeKarte (EinzelKarte AS Karte) STATIC
   PRINT " "; EinzelKarte.Farbe;
   SELECT CASE EinzelKarte.Wert
      CASE 13
         PRINT "Knig"
      CASE 12
         PRINT "Dame "
      CASE 11
         PRINT "Bube "
      CASE 1
         PRINT "As   "
      CASE ELSE
         PRINT USING "  ## "; EinzelKarte.Wert
   END SELECT

END SUB

